unit shortfixunit;
{ Fixed point with Fractional part computation using short integers}
interface
uses memtypes,quickdraw,osintf,toolintf,packintf,fixmath;
const	shortfix_fraction_digits=12;
		maxshortfixarray=$3FFF;
		shortfixbits=16;
		shortfixbytes=2;
		
type	shortfix=integer;
		shortfixarray=array[1..maxshortfixarray] of shortfix;
		shortfixarrayptr=^shortfixarray;
		shortfixarrayhandle=^shortfixarray;

	function sfixmul(i,j:shortfix):shortfix;
	function sfixdiv(i,j:shortfix):shortfix;
	function sfix2x(i:shortfix):extended;
	function x2sfix(x:extended):shortfix;
	function long2sfix(l:longint):shortfix;
	function sfix2long(i:shortfix):longint;

implementation
{difference in the number of fractional digits}
const short_full_digit_diff=4;

function sfixmul(i,j:shortfix):shortfix;
{ operands:
  xxxx.dddd dddd dddd
  32 bit product:
  yyyy yyyy dddd dddd dddd dddd dddd dddd
}
begin
sfixmul:=LoWrd(Bsr(longint(i)*longint(j),shortfix_fraction_digits))
end;

function sfixdiv(i,j:shortfix):shortfix;
{ operands:
  xxxx.dddd dddd dddd
  shift numerator before divide
  xxxx.dddd dddd dddd 0000 0000 0000
}
begin
sfixdiv:=LoWrd(Bsl(longint(i),shortfix_fraction_digits) div longint(j));
end;

function sfix2x(i:shortfix):extended;
{shift left and convert from fixed to extended}
begin
sfix2x:=fix2x(fixed(longint(bsl(i,short_full_digit_diff))));
end;

function x2sfix(x:extended):shortfix;
{convert to fixed and shift right}
begin
x2sfix:=LoWrd(Bsr(x2fix(x),short_full_digit_diff));
end;

function long2sfix(l:longint):shortfix;
begin
long2sfix:=LoWrd(Bsl(l,shortfix_fraction_digits));
end;

function sfix2long(i:shortfix):longint;
begin
sfix2long:=integer(bsr(i,shortfix_fraction_digits))
end;
end.